
#define _WIN32_WINNT    0x0400

#include <winstl.h>
#include <winstl_performance_counter.h>

#include <stdio.h>

winstl_ns_using(performance_counter)

static LPVOID   s_pvMainFiber   =   0;

void WINAPI CounterFiberFunc(LPVOID pv);
void CounterIncrementFunc(LPVOID pv);

int main(int /* argc */, char ** /*argv*/)
{
    s_pvMainFiber       =   ::ConvertThreadToFiber(0);

    int                                 i;
    const int                           iMax    =   5000000;
    performance_counter counter;
    performance_counter::interval_type  tm_fiber;
    performance_counter::interval_type  tm_func;

    LPVOID                              pvWorker = ::CreateFiber(0, CounterFiberFunc, &i);

    for(counter.start(), i = 0; i < iMax; )
    {
        ::SwitchToFiber(pvWorker);
    }
    counter.stop();
    tm_fiber = counter.get_milliseconds();

    for(counter.start(), i = 0; i < iMax; )
    {
        CounterIncrementFunc(&i);
    }
    counter.stop();
    tm_func = counter.get_milliseconds();

    ::DeleteFiber(pvWorker);

#if defined(_STLSOFT_COMPILER_IS_BORLAND) || \
    defined(_STLSOFT_COMPILER_IS_INTEL) || \
    defined(_STLSOFT_COMPILER_IS_MSVC)    
 #define _i64_fmt   "%I64d"
#else
 #define _i64_fmt   "%lld"
#endif /* compiler */

    printf("fiber:     " _i64_fmt "\n", tm_fiber);
    printf("func-call: " _i64_fmt "\n", tm_func);

    return 0;
}

void WINAPI CounterFiberFunc(LPVOID pv)
{
    int &i  =   *(int*)pv;

    for(;;)
    {
        ++i;

        ::SwitchToFiber(s_pvMainFiber);
    }
}

void CounterIncrementFunc(LPVOID pv)
{
    int &i  =   *(int*)pv;

    ++i;
}
